function Mutator(options) {
  this._options = this._mergeProperties({ interval: 50, duration: 1000, mutation: function(pos){ return ((-Math.cos(pos * Math.PI) / 2) + 0.5);	}, callback: function() {} }, options);
  this._mutants = [];
  this._frame = 0;
  this._timer = null;
}

Mutator.prototype = {
  _mergeProperties : function(base, user) {
  	user = user || {};
  	var result = {};
  	for (var property in base) {
  	  result[property] = (user.hasOwnProperty(property) ? user[property] : base[property]);
  	}
  	return result;
  },
  
  _doStep : function() {
		var step = (this._options.interval / this._options.duration);
		if (Math.abs(step) >= Math.abs(this._frame - 1)) {
			this._frame = 1;
		}
		else {
			this._frame += step;
		}
		dump(step + "\n");
		dump(this._frame + "\n");
		try {
  		var value = this._options.mutation(this._frame);
  		for (var i=0; i<this._mutants.length; i++) {
  			if (this._mutants[i].doStep) {
  				this._mutants[i].doStep(value);
  			}
  			else {
  				this._mutants[i](value);
  			}
  		}
		}
		finally {
			if (this._frame == 1) {
				window.clearInterval(this._timer);
				this._timer = null;
				this._options.callback.call(this);
			}
		}
  },
  
  addMutant : function(mutant) {
    this._mutants.push(mutant);
  },
  
  clearMutants : function() {
    this._mutants = [];
  },
  
	mutate : function() {
		this._frame = 0;
		if (!this._timer) {
		  var self = this;
			this._timer = setInterval(function() { self._doStep(); }, self._options.interval);
		}
	}
};


// changes a numeric style property between two values
function NumericStyleMutant(elems, property, from, to, units) {
	this._elems = elems;
  this._property = property;
	this._from = parseFloat(from);
	this._to = parseFloat(to);
	this._units = units;
}

NumericStyleMutant.prototype = {
	doStep : function(step) {
		var style = this._from + ((this._to - this._from) * step);
		if (this._property != "opacity")
  		style = Math.round(style) + this._units;
  		
		for (var i=0; i<this._elems.length; i++) {
      this._elems[i].style[this._property] = style;
		}
	}
}
